/* bootpack̃C */

#include "bootpack.h"
#include <stdio.h>
#include <string.h>

#define N 20

extern struct FIFO8 keyfifo;

int put_code(struct BOOTINFO *binfo, int x, int y, int *p)
{
	char s[40];
	
	if (p[-1] == 0xe0) {
		sprintf(s, "%02X%02X%s", p[-1], p[0] & 0x7f, (p[0] & 0x80 ? "-" : "+"));
		boxfill8(binfo->vram, binfo->scrnx, COL8_008484, x, y, x + 47, y + 15);
		putfonts8_asc(binfo->vram, binfo->scrnx, x, y, COL8_FFFFFF, s);
		return 2;
	} else {
		sprintf(s, "%02X%s", p[0] & 0x7f, (p[0] & 0x80 ? "-" : "+"));
		boxfill8(binfo->vram, binfo->scrnx, COL8_008484, x, y, x + 47, y + 15);
		putfonts8_asc(binfo->vram, binfo->scrnx, x, y, COL8_FFFFFF, s);
		return 1;
	}
}

void HariMain(void)
{
	struct BOOTINFO *binfo = (struct BOOTINFO *) ADR_BOOTINFO;
	char s[40], mcursor[256], keybuf[32];
	int mx, my, i, y, last[N], *p;

	init_gdtidt();
	init_pic();
	io_sti(); /* IDT/PIC̏ÎCPŮ荞݋֎~ */

	fifo8_init(&keyfifo, 32, keybuf);
	io_out8(PIC0_IMR, 0xf9); /* PIC1ƃL[{[h(11111001) */
	io_out8(PIC1_IMR, 0xef); /* }EX(11101111) */

	init_palette();
	init_screen8(binfo->vram, binfo->scrnx, binfo->scrny);
#if 0
	mx = (binfo->scrnx - 16) / 2; /* ʒɂȂ悤ɍWvZ */
	my = (binfo->scrny - 28 - 16) / 2;
	init_mouse_cursor8(mcursor, COL8_008484);
	putblock8_8(binfo->vram, binfo->scrnx, 16, 16, mx, my, mcursor, 16);
	sprintf(s, "(%d, %d)", mx, my);
	putfonts8_asc(binfo->vram, binfo->scrnx, 0, 0, COL8_FFFFFF, s);
#endif
	memset(last, sizeof(int) * N, 0);

	for (;;) {
		io_cli();
		if (fifo8_status(&keyfifo) == 0) {
			io_stihlt();
		} else {
			i = fifo8_get(&keyfifo);
			io_sti();
			
			memmove(last, last + 1, sizeof(int) * (N - 1));
			last[N - 1] = i;
			
			p = last + N - 1;
			for (y = 0; y < N / 2; y++) {
				p -= put_code(binfo, 0, y * 16, p);
			}
		}
	}
}
